% MB_Plot_3D_GEX_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Northern Leg of Glacier Extensional Fault

dip = 60;

GEX1 = importdata('Glacier_Extensional_Fault1_points.csv');
% x surface points
XS = GEX1.data(:,1);
% y surface points
YS = GEX1.data(:,2);


X = [XS(1:4);XS(7:4:84)];X(24) = XS(85);
Y = [YS(1:4);YS(7:4:84)];Y(24) = YS(85);
Z = -ones(numel(X),1);

figure
plot(X,Y,'k.')
axis equal

% projection angle
theta = 10*(pi/180);

d = numel(X-1);
% northern U. medium fault leg 1500m spacing
for i=1
    X(d+1+4*(i-1):d+4*i) = XS(1:4)-1200*i*cos(dip*(pi/180))*cos(theta);
    Y(d+1+4*(i-1):d+4*i) = YS(1:4)+1200*i*cos(dip*(pi/180))*sin(theta);
    Z(d+1+4*(i-1):d+4*i) = -1200*i;
end

% d = numel(X);
% % northern L. medium fault leg 600m spacing
% for i=1:2
%     X(d+1+2*(i-1):d+2*i) = X(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
%     Y(d+1+2*(i-1):d+2*i) = Y(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
%     Z(d+1+2*(i-1):d+2*i) = -600*i;
% end

d = numel(X);
% middle fault leg 300m spacing
set = [7:4:84];set(20)=84;
for i=1
        X(d+1+20*(i-1):d+20*i) = XS(7:4:84)-1200*i*cos(dip*(pi/180))*cos(theta);
        Y(d+1+20*(i-1):d+20*i) = YS(7:4:84)+120*i*cos(dip*(pi/180))*sin(theta);
        Z(d+1+20*(i-1):d+20*i) = -1200*i;
end
% e = -Z(numel(Z));
% d = numel(X);
% for i=1
%         X(d+1+40*(i-1):d+40*i) = [X(7:2:84);X(84)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
%         Y(d+1+40*(i-1):d+40*i) = [Y(7:2:84);Y(84)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
%         Z(d+1+40*(i-1):d+40*i) = -(e+600*i);
% end

d = numel(X);
for i=1
        X(d+1+1*(i-1):d+1*i) = [XS(85)]-(1200*i)*cos(dip*(pi/180))*sin(30*(pi/180));
        Y(d+1+1*(i-1):d+1*i) = [YS(85)]-(1200*i)*cos(dip*(pi/180))*cos(30*(pi/180));
        Z(d+1+1*(i-1):d+1*i) = -1200*i;
end
d = numel(X);
for i=1
        X(d+1+1*(i-1):d+1*i) = [XS(83)]-(1200*i)*cos(dip*(pi/180))*sin(30*(pi/180));
        Y(d+1+1*(i-1):d+1*i) = [YS(83)]-(1200*i)*cos(dip*(pi/180))*cos(30*(pi/180));
        Z(d+1+1*(i-1):d+1*i) = -1200*i;
end

%% Southern Leg of Glacier Extensional Fault
GEX2 = importdata('Glacier_Extensional_Fault2_points.csv');
% x surface points
xs = GEX2.data(:,1);
% y surface points
ys = GEX2.data(:,2);

x = xs(1:4:49);
y = ys(1:4:49);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle
theta = 30*(pi/180);

% d = numel(x);
% % northern U. medium fault leg 1500m spacing
% for i=1
%     x(d+1+4*(i-1):d+4*i) = x(1:4)-1200*i*cos(dip*(pi/180))*cos(theta);
%     y(d+1+4*(i-1):d+4*i) = y(1:4)+1200*i*cos(dip*(pi/180))*sin(theta);
%     z(d+1+4*(i-1):d+4*i) = -1200*i;
% end
% 
% d = numel(x);
% % northern L. medium fault leg 600m spacing
% for i=1:2
%     x(d+1+2*(i-1):d+2*i) = x(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
%     y(d+1+2*(i-1):d+2*i) = y(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
%     z(d+1+2*(i-1):d+2*i) = -600*i;
% end

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+13*(i-1):d+13*i) = xs(1:4:49)-1200*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = ys(1:4:49)-1200*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -1200*i;
end
% e = -z(numel(z));
% d = numel(z);
% for i=1
%         x(d+1+25*(i-1):d+25*i) = x(1:2:49)-(e+600*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+25*(i-1):d+25*i) = y(1:2:49)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+25*(i-1):d+25*i) = -(e+600*i);
% end

% d = numel(x);
% for i=1:4
%         x(d+1+2*(i-1):d+2*i) = [x(84:85)]-(300*i)*cos(dip*(pi/180))*sin(30*(pi/180));
%         y(d+1+2*(i-1):d+2*i) = [y(84:85)]-(300*i)*cos(dip*(pi/180))*cos(30*(pi/180));
%         z(d+1+2*(i-1):d+2*i) = -300*i;
% end
% d = numel(x);
% for i=1:2
%         x(d+1+1*(i-1):d+1*i) = [x(83)]-(600+300*i)*cos(dip*(pi/180))*sin(30*(pi/180));
%         y(d+1+1*(i-1):d+1*i) = [y(83)]-(600+300*i)*cos(dip*(pi/180))*cos(30*(pi/180));
%         z(d+1+1*(i-1):d+1*i) = -600-300*i;
% end


% Triangular Mesh
XYZgex1(:,1) = X;XYZgex1(:,2) = Y;XYZgex1(:,3) = Z;
XYZgex2(:,1) = x;XYZgex2(:,2) = y;XYZgex2(:,3) = z;

CONgex1=Delaunay2_5D(XYZgex1);
CONgex2=Delaunay2_5D(XYZgex2);

figure
plot3(XYZgex1(:,1),XYZgex1(:,2),XYZgex1(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Glacial Extensional Fault','fontsize',12)
hold on
plot3(XYZgex2(:,1),XYZgex2(:,2),XYZgex2(:,3),'k.');
xlim([min(XYZgex1(:,1)) max(XYZgex2(:,1))]);
ylim([min(XYZgex2(:,2)) max(XYZgex1(:,2))]);

for i=1:numel(CONgex1(:,1))
    plot3(XYZgex1([CONgex1(i,:) CONgex1(i,1)],1),XYZgex1([CONgex1(i,:) CONgex1(i,1)],2),XYZgex1([CONgex1(i,:) CONgex1(i,1)],3),'b-')
end

for i=1:numel(CONgex2(:,1))
    plot3(XYZgex2([CONgex2(i,:) CONgex2(i,1)],1),XYZgex2([CONgex2(i,:) CONgex2(i,1)],2),XYZgex2([CONgex2(i,:) CONgex2(i,1)],3),'b-')
end

[tngex1,nvecgex1] = PlotTriNormals(CONgex1,XYZgex1,convention);
[tngex2,nvecgex2] = PlotTriNormals(CONgex2,XYZgex2,convention);